/* Generated automatically by the program `genoutput'
from the machine description file `md'.  */

#include "config.h"
#include "rtl.h"
#include "regs.h"
#include "hard-reg-set.h"
#include "real.h"
#include "conditions.h"
#include "insn-flags.h"
#include "insn-config.h"

#ifndef __STDC__
#define const
#endif

#include "output.h"
#include "aux-output.c"

#ifndef INSN_MACHINE_INFO
#define INSN_MACHINE_INFO struct dummy1 {int i;}
#endif


static char *
output_0 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  int addend;
  /* compute sum, with signs */
  addend = INTVAL (operands[3]) * (GET_CODE (operands[1]) == PLUS ? 1 : -1);
  addend += INTVAL (operands[6]) * (GET_CODE (operands[5]) == PLUS ? 1 : -1);
  if (addend != 0)
    {
      operands[0] = gen_rtx (CONST_INT, VOIDmode, addend);
      return "addi%:\t%4,%2,%0";
    }
  /* value is zero; copy */
  if (REGNO (operands[4]) != REGNO (operands[2]))
    return "add%:\t%4,%2,$0";
  /* copying to self; punt */
  return " # null operation: additive operands cancel (%0,%2)";
}
}

static char *
output_3 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  int number;
  if (GET_CODE (operands[2]) != CONST_INT)
    return "add%:\t%0,%1,%2";

  number = INTVAL (operands[2]);
  if (((unsigned) (number + 0x8000) > 0xffff))
    {
      operands[3] = gen_rtx (REG, SImode, 1);	/* assembler temp. */
      return ".set\tnoat\n\tli\t%3,%2\n\tadd%:\t%0,%1,%3\n\t.set\tat";
    }

  return (number < 0) ? "sub%:\t%0,%1,%n2" : "add%:\t%0,%1,%2";
}
}

static char *
output_4 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return (GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) < 0)
    ? "sub%:\t%0,%1,%n2"
    : "add%:\t%0,%1,%2";
}
}

static char *
output_7 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  int number;
  if (GET_CODE (operands[2]) != CONST_INT)
    return "sub%:\t%0,%1,%2";

  number = INTVAL (operands[2]);
  if (((unsigned) (number + 0x8000) > 0xffff))
    {
      operands[3] = gen_rtx (REG, SImode, 1);	/* assembler temp. */
      return ".set\tnoat\n\tli\t%3,%2\n\tsub%:\t%0,%1,%3\n\t.set\tat";
    }

  return (number < 0) ? "add%:\t%0,%1,%n2" : "sub%:\t%0,%1,%2";
}
}

static char *
output_8 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return (GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) < 0)
    ? "add%:\t%0,%1,%n2"
    : "sub%:\t%0,%1,%2";
}
}

static char *
output_23 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return (GET_CODE (operands[2]) == CONST_INT)
		? "andi\t%0,%1,%x2"
		: "and\t%0,%1,%2";
}
}

static char *
output_27 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return (GET_CODE (operands[2]) == CONST_INT)
		? "ori\t%0,%1,%x2"
		: "or\t%0,%1,%2";
}
}

static char *
output_29 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  return (GET_CODE (operands[2]) == CONST_INT)
		? "xori\t%0,%1,%x2"
		: "xor\t%0,%1,%2";
}
}

static char *
output_31 (operands, insn)
     rtx *operands;
     rtx insn;
{

    output_asm_insn ("sll\t%0,%1,0x10\t#truncsihi2\t %1 -> %0",
                    operands);
    return "sra\t%0,%0,0x10\t#truncsihi2\t %1 -> %0";

}

static char *
output_34 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (which_alternative == 0)
    {
      output_asm_insn ("sll\t%0,%1,0x10\t#zero_extendhisi2\t %1 -> %0",
		       operands);
      return "srl\t%0,%0,0x10\t#zero_extendhisi2\t %1 -> %0";
    }
  else
    return "lhu\t%0,%1\t#zero extendhisi2 %1 -> %0";
}
}

static char *
output_35 (operands, insn)
     rtx *operands;
     rtx insn;
{

    output_asm_insn ("sll\t%0,%1,0x18\t#zero_extendqihi2\t %1 -> %0",
                    operands);
    return "srl\t%0,%0,0x18\t#zero_extendqihi2\t %1 -> %0";
  
}

static char *
output_36 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (which_alternative == 0)
    {
      return "andi\t%0,%1,0xff\t#zero_extendqisi2\t %1 -> %0";
    }
  else
    return "lbu\t%0,%1\t#zero extendqisi2 %1 -> %0";
}
}

static char *
output_37 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (which_alternative == 0)
    {
      output_asm_insn ("sll\t%0,%1,0x10\t#sign extendhisi2\t %1 -> %0",
		       operands);
      return "sra\t%0,%0,0x10\t#sign extendhisi2\t %1 -> %0";
    }
  else
    return "lh\t%0,%1\t#sign extendhisi2 %1 -> %0";
}
}

static char *
output_38 (operands, insn)
     rtx *operands;
     rtx insn;
{

    output_asm_insn ("sll\t%0,%1,0x18\t#sign extendqihi2\t %1 -> %0",
                    operands);
    return "sra\t%0,%0,0x18\t#sign extendqihi2\t %1 -> %0";
  
}

static char *
output_39 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (which_alternative == 0)
    {
      output_asm_insn ("sll\t%0,%1,0x18\t#sign extendqisi2\t %1 -> %0",
		       operands);
      return "sra\t%0,%0,0x18\t#sign extendqisi2\t %1 -> %0";
    }
  else
    return "lb\t%0,%1\t#sign extendqisi2 %1 -> %0";
}
}

static char *
output_55 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  extern rtx adj_offsettable_operand ();
  extern int offsettable_address_p ();

  if (which_alternative == 0)
    {
      /* Move REGISTER <- REGISTER */
      if (REGNO (operands[0]) != (REGNO (operands[1])+1))
	return "move\t%0,%1\n\tmove\t%D0,%D1";
      else
	return "move\t%D0,%D1\n\tmove\t%0,%1";
    }

  else if (which_alternative == 1)
    {
      if (GET_CODE (operands[1]) == MEM)
	{
	  /* REGISTER <- MEMORY */
	  if (offsettable_address_p (1, DImode, XEXP (operands[1], 0)))
	    {
	      operands[2] = adj_offsettable_operand (operands[1], 4);
	      return "lw\t%0,%1\n\tlw\t%D0,%2";
	    }

	  else
	    {
	      operands[2] = gen_rtx (REG, Pmode, 1);
	      return ".set\tnoat\n\tla\t%2,%1\n\tlw\t%0,0(%2)\n\tlw\t%D0,4(%2)\n\tset\tat";
	    }
	}

      /* REGISTER <- small integer constant */
      else if (CONSTANT_P (operands[1]))
	{
	  operands[2] = gen_rtx (CONST_INT, VOIDmode, INTVAL (operands[1]) >= 0 ? 0 : -1);
	  return "li\t%M0,%2\n\tli\t%L0,%1";
	}

      /* Register <- large integer constant */
      else if (GET_CODE (operands[1]) == CONST_DOUBLE)
	{
	  operands[2] = gen_rtx (CONST_INT, VOIDmode, CONST_DOUBLE_LOW (operands[1]));
	  operands[3] = gen_rtx (CONST_INT, VOIDmode, CONST_DOUBLE_HIGH (operands[1]));
	  return "li\t%M0,%3\n\tli\t%L0,%2";
	}
    }

  else if (which_alternative == 2 && GET_CODE (operands[0]) == MEM)
  /* MAKE CHECK HERE FOR SHARED LOCATION! */
    {
      /* Memory <- Register */
      if (offsettable_address_p (1, DImode, XEXP (operands[0], 0)))
	{
	  operands[2] = adj_offsettable_operand (operands[0], 4);
	  return "sw\t%1,%0\n\tsw\t%D1,%2";
	}

      else
	{
	  operands[2] = gen_rtx (REG, Pmode, 1);
	  return ".set\tnoat\n\tla\t%2,%0\n\tsw\t%1,0(%2)\n\tsw\t%D1,4(%2)\n\tset\tat";
	}
    }

  abort_with_insn (insn, "impossible case in movdi");
  return "";
}
}

static char *
output_56 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  enum rtx_code code0 = GET_CODE (operands[0]);
  enum rtx_code code1 = GET_CODE (operands[1]);

  if (code0 == REG && code1 == REG)
    return "move\t%0,%1";

  else if (code0 == REG && code1 == MEM)
    return "lw\t%0,%1";

  else if (code0 == MEM && code1 == REG)    	{
	  return "sw\t%1,%0";    
  }   else if (code0 == REG && code1 == CONST_INT)
    	return "li\t%0,%1";
  else if (code0 == MEM && code1 == CONST_INT && INTVAL (operands[1])  == 0)   {
          return "sw\t$0,%0";
  }  else if (code0 == REG && CONSTANT_P (operands[1]))
    return "la\t%0,%a1";

  else if (code0 == REG && code1 == PLUS
	   && GET_CODE (XEXP (operands[1], 0)) == REG
	   && GET_CODE (XEXP (operands[1], 1)) == CONST_INT)
    {
      operands[2] = XEXP (operands[1], 0);
      operands[3] = XEXP (operands[1], 1);
      return "add%:\t%0,%2,%3";
    }

  abort_with_insn (insn, "Bad movsi");
  return 0;
}
}

static char *
output_57 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  enum rtx_code code0 = GET_CODE (operands[0]);
  enum rtx_code code1 = GET_CODE (operands[1]);

  if (code0 == REG && code1 == REG)
    return "move\t%0,%1";

  else if (code0 == REG && code1 == MEM)
    return "lh\t%0,%1";

  else if (code0 == MEM && code1 == REG)
    return "sh\t%1,%0";

  else if (code0 == REG && code1 == CONST_INT)
    return "li\t%0,%1";

  else if (code0 == MEM && code1 == CONST_INT && INTVAL (operands[1]) == 0)
    return "sh\t$0,%0";

  else if (code0 == REG && CONSTANT_P (operands[1]))
    return "la\t%0,%a1";

  else if (code0 == REG && code1 == PLUS
	   && GET_CODE (XEXP (operands[1], 0)) == REG
	   && GET_CODE (XEXP (operands[1], 1)) == CONST_INT)
    {
      operands[2] = XEXP (operands[1], 0);
      operands[3] = XEXP (operands[1], 1);
      return "add%:\t%0,%2,%3";
    }

  abort_with_insn (insn, "Bad movhi");
  return 0;
}
}

static char *
output_58 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  enum rtx_code code0 = GET_CODE (operands[0]);
  enum rtx_code code1 = GET_CODE (operands[1]);

  if (code0 == REG && code1 == REG)
    return "move\t%0,%1";

  else if (code0 == REG && code1 == MEM)
    return "lb\t%0,%1";

  else if (code0 == MEM && code1 == REG)
    return "sb\t%1,%0";

  else if (code0 == REG && code1 == CONST_INT)
    return "li\t%0,%1";

  else if (code0 == MEM && code1 == CONST_INT && INTVAL (operands[1]) == 0)
    return "sb\t$0,%0";

  else if (code0 == REG && CONSTANT_P (operands[1]))
    return "la\t%0,%a1";

  else if (code0 == REG && code1 == PLUS
	   && GET_CODE (XEXP (operands[1], 0)) == REG
	   && GET_CODE (XEXP (operands[1], 1)) == CONST_INT)
    {
      operands[2] = XEXP (operands[1], 0);
      operands[3] = XEXP (operands[1], 1);
      return "add%:\t%0,%2,%3";
    }

  abort_with_insn (insn, "Bad movqi");
  return 0;
}
}

static char *
output_59 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  enum rtx_code code0 = GET_CODE (operands[0]);
  enum rtx_code code1 = GET_CODE (operands[1]);

  if (code0 == REG)
    {
      if (code1 == REG)
	{
	  if (FP_REG_P (REGNO (operands[0])))
	    {
	      if (FP_REG_P (REGNO (operands[1])))
		return "mov.s\t%0,%1";
	      else
		return "mtc1\t%1,%0\t\t# Calling sequence trick";
	    }

	  else if (FP_REG_P (REGNO (operands[1])))
	    return "mfc1\t%0,%1\t\t# Calling sequence trick";

	  else
	    return "move\t%0,%1";
	}

      else if (code1 == CONST_DOUBLE)
	return "li.s\t%0,%1";

      else if (code1 == MEM)
	return (GP_REG_P (REGNO (operands[0]))) ? "lw\t%0,%1" : "l.s\t%0,%1";
    }

    /* MAKE CHECK HERE */
  else if (code0 == MEM && code1 == REG)
    return (GP_REG_P (REGNO (operands[1]))) ? "sw\t%1,%0" : "s.s\t%1,%0";

  abort_with_insn (insn, "Bad movsf");
  return "";
}
}

static char *
output_60 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  extern rtx adj_offsettable_operand ();
  extern int offsettable_address_p ();

  enum rtx_code code0 = GET_CODE (operands[0]);
  enum rtx_code code1 = GET_CODE (operands[1]);

  if (code0 == REG)
    {
      if (code1 == REG)
	{
	  if (FP_REG_P (REGNO (operands[0])))
	    {
	      if (FP_REG_P (REGNO (operands[1])))
		return "mov.d\t%0,%1";
	      else
		return "mtc1\t%L1,%0\t\t# Calling sequence trick\n\tmtc1\t%M1,%D0";
	    }

	  else if (FP_REG_P (REGNO (operands[1])))
	    return "mfc1\t%L0,%1\t\t# Calling sequence trick\n\tmfc1\t%M0,%D1";

	  else if (REGNO (operands[0]) != (REGNO (operands[1])+1))
	    return "move\t%0,%1\n\tmove\t%D0,%D1";

	  else
	    return "move\t%D0,%D1\n\tmove\t%0,%1";
	}

      else if (code1 == CONST_DOUBLE)
	return "li.d\t%0,%1";

      else if (code1 == MEM)
	{
	  if (FP_REG_P (REGNO (operands[0])))
	    return "l.d\t%0,%1";

	  else if (offsettable_address_p (1, DFmode, XEXP (operands[1], 0)))
	    {
	      operands[2] = adj_offsettable_operand (operands[1], 4);
	      if (reg_mentioned_p (operands[0], operands[1]))
		return "lw\t%D0,%2\n\tlw\t%0,%1";
	      else
		return "lw\t%0,%1\n\tlw\t%D0,%2";
	    }

	  else
	    {
	      operands[2] = gen_rtx (REG, Pmode, 1);
	      return ".set\tnoat\n\tla\t%2,%1\n\tlw\t%0,0(%2)\n\tlw\t%D0,4(%2)\n\tset\tat";
	    }
	}
    }

  else if (code0 == MEM && code1 == REG)
    {
      if (FP_REG_P (REGNO (operands[1])))
	return "s.d\t%1,%0";

      else if (offsettable_address_p (1, DFmode, XEXP (operands[0], 0)))
	{
	  operands[2] = adj_offsettable_operand (operands[0], 4);
	  /* MAKE CHECK HERE */
	  return "sw\t%1,%0\n\tsw\t%D1,%2";
	}

      else
	{
	  /* MAKE CHECK HERE */
	  operands[2] = gen_rtx (REG, Pmode, 1);
	  return ".set\tnoat\n\tla\t%2,%0\n\tsw\t%1,0(%2)\n\tsw\t%D1,4(%2)\n\tset\tat";
	}
    }

  abort_with_insn (insn, "Bad movdf");
  return "";
}
}

static char *
output_61 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (GET_CODE (operands[2]) == CONST_INT)
    operands[2] = gen_rtx (CONST_INT, VOIDmode, (XINT (operands[2], 0))& 0x1f);

  return "sll\t%0,%1,%2";
}
}

static char *
output_62 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (GET_CODE (operands[2]) == CONST_INT)
    operands[2] = gen_rtx (CONST_INT, VOIDmode, (XINT (operands[2], 0))& 0x1f);

  return "sra\t%0,%1,%2";
}
}

static char *
output_63 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (GET_CODE (operands[2]) == CONST_INT)
    operands[2] = gen_rtx (CONST_INT, VOIDmode, (XINT (operands[2], 0))& 0x1f);

  return "srl\t%0,%1,%2";
}
}

static char *
output_68 (operands, insn)
     rtx *operands;
     rtx insn;
{

    compare_collect (SImode, operands[0], operands[1]);
    return "\t\t\t\t# cmpsi\t%0,%1";

}

static char *
output_69 (operands, insn)
     rtx *operands;
     rtx insn;
{

    compare_collect (SImode, operands[0], gen_rtx (REG, SImode, 0));
    return "\t\t\t\t# (set (cc0)\t%0)";

}

static char *
output_70 (operands, insn)
     rtx *operands;
     rtx insn;
{

    compare_collect (DFmode, operands[0], operands[1]);
    return " #\t\t\t\tcmpdf\t%0,%1" ;

}

static char *
output_71 (operands, insn)
     rtx *operands;
     rtx insn;
{

    compare_collect (SFmode, operands[0], operands[1]);
    return "\t\t\t\t# cmpsf\t%0,%1" ;

}

static char *
output_72 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  if (GET_CODE (operands[0]) == REG)
    return "j\t%0";
  else
    return "j\t%l0";
}
}

static char *
output_74 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.eq.d\t%0,%1\t\t# beq", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# beq", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.eq.s\t%0,%1\t\t# beq", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# beq", br_ops);
    }
  else
    {
      output_asm_insn ("beq\t%0,%1,%2\t\t# beq", br_ops);
    }
  return "";
}
   
}

static char *
output_75 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.eq.d\t%0,%1\t\t# bne", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# bne", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.eq.s\t%0,%1\t\t# bne", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# bne", br_ops);
    }
  else
    {
      output_asm_insn ("bne\t%0,%1,%2\t\t# bne", br_ops);
    }
  return "";
}


}

static char *
output_76 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.le.d\t%0,%1\t\t# bgt branch %0 > %1", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# bgt", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.le.s\t%0,%1\t\t# bgt branch %0 > %1", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# bgt", br_ops);
    }
  else
    {
      output_asm_insn ("bgt\t%0,%1,%2\t\t# bgt", br_ops);
    }
  return "";
}


}

static char *
output_77 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.lt.d\t%0,%1\t\t# blt", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# blt", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.lt.s\t%0,%1\t\t# blt", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# blt", br_ops);
    }
  else
    {
      output_asm_insn ("blt\t%0,%1,%2\t\t# blt", br_ops);
    }
  return " #\tblt\t%l0\t\t# blt";
}

}

static char *
output_78 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.le.d\t%0,%1\t\t# bgtu", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# bgtu", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.le.s\t%0,%1\t\t# bgtu", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# bgtu", br_ops);
    }
  else
    {
      output_asm_insn ("bgtu\t%0,%1,%2\t\t# bgtu", br_ops);
    }
  return " #\tbgtu\t%l0\t\t# bgtu";
}

}

static char *
output_79 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.lt.d\t%0,%1\t\t# bltu", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# bltu", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.lt.s\t%0,%1\t\t# bltu", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# bltu", br_ops);
    }
  else
    {
      output_asm_insn ("bltu\t%0,%1,%2\t\t# bltu", br_ops);
    }
  return "";
}

}

static char *
output_80 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.lt.d\t%0,%1\t\t# bge", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# bge", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.lt.s\t%0,%1\t\t# bge", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# bge", br_ops);
    }
  else
    {
      output_asm_insn ("bge\t%0,%1,%2\t\t# bge", br_ops);
    }
  return "";
}

}

static char *
output_81 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.lt.d\t%0,%1\t\t# bgeu", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# bgeu", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.lt.s\t%0,%1\t\t# bgeu", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# bgeu", br_ops);
    }
  else
    {
      output_asm_insn ("bgeu\t%0,%1,%2\t\t# bgeu", br_ops);
    }
  return "";
}

}

static char *
output_82 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.le.d\t%0,%1\t\t# ble", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# ble", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.le.s\t%0,%1\t\t# ble", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# ble", br_ops);
    }
  else
    {
      output_asm_insn ("ble\t%0,%1,%2\t\t# ble", br_ops);
    }
  return "";
}

}

static char *
output_83 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.le.d\t%0,%1\t\t# ble", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# ble", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.le.s\t%0,%1\t\t# ble", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# ble", br_ops);
    }
  else
    {
      output_asm_insn ("bleu\t%0,%1,%2\t\t# bleu", br_ops);
    }
  return " #\tbleu\t%l0\t\t# bleu";
}

}

static char *
output_84 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.eq.d\t%0,%1\t\t# beq", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# beq", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.eq.s\t%0,%1\t\t# beq", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# beq", br_ops);
    }
  else
    {
      output_asm_insn ("beq\t%0,%1,%2\t\t# beq Inv.", br_ops);
    }
  return "";
}

}

static char *
output_85 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.eq.d\t%0,%1\t\t# bne", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# bne", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.eq.s\t%0,%1\t\t# bne", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# beq", br_ops);
    }
  else
    {
      output_asm_insn ("bne\t%0,%1,%2\t\t# bne Inv.", br_ops);
    }
  return "";
}


}

static char *
output_86 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.le.d\t%0,%1\t\t# bgt", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# beq", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.le.s\t%0,%1\t\t# bgt", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# beq", br_ops);
    }
  else
    {
      output_asm_insn ("bgt\t%0,%1,%2\t\t# bgt Inv.", br_ops);
    }
  return "";
}

}

static char *
output_87 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.le.d\t%0,%1\t\t# bgt", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# beq", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.le.s\t%0,%1\t\t# bgt", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# beq", br_ops);
    }
  else
    {
      output_asm_insn ("bgtu\t%0,%1,%2\t\t# bgtu Inv.", br_ops);
    }
  return " #\tbgtu\t%l0\t\t# bgtu";
}

}

static char *
output_88 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.lt.d\t%0,%1\t\t# blt", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# beq", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.lt.s\t%0,%1\t\t# blt", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# beq", br_ops);
    }
  else
    {
      output_asm_insn ("blt\t%0,%1,%2\t\t# blt Inv.", br_ops);
    }
  return "";
}

}

static char *
output_89 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.lt.d\t%0,%1\t\t# bltu", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# bltu", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.lt.s\t%0,%1\t\t# bltu", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# bltu", br_ops);
    }
  else
    {
      output_asm_insn ("bltu\t%0,%1,%2\t\t# bltu Inv.", br_ops);
    }
  return " #\tbltu\t%l0\t\t# bltu";
}

}

static char *
output_90 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.lt.d\t%0,%1\t\t# bge", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# bge (DF) Inv.", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.lt.s\t%0,%1\t\t# bge", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# bge (SF) Inv.", br_ops);
    }
  else
    {
      output_asm_insn ("bge\t%0,%1,%2\t\t# bge Inv.", br_ops);
    }
  return "";
}

}

static char *
output_91 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.lt.d\t%0,%1\t\t# bge", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# bgeu (DF)  Inv.", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.lt.s\t%0,%1\t\t# bge", br_ops);
      output_asm_insn ("bc1f\t%2\t\t# bgeu (SF )Inv.", br_ops);
    }
  else
    {
      output_asm_insn ("bgeu\t%0,%1,%2\t\t# bgeu Inv.", br_ops);
    }
  return " #\tbgeu\t%l0\t\t# bgeu";
}

}

static char *
output_92 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.le.d\t%0,%1\t\t# ble", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# ble", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.le.s\t%0,%1\t\t# ble", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# ble", br_ops);
    }
  else
    {
      output_asm_insn ("ble\t%0,%1,%2\t\t# ble Inv.", br_ops);
    }
  return "";
}

}

static char *
output_93 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  rtx br_ops[3];
  enum machine_mode mode;
  compare_restore (br_ops,  &mode, insn);
  br_ops[2] = operands[0];
  if (mode == DFmode)
    {
      output_asm_insn ("c.le.d\t%0,%1\t\t# bleu", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# bleu", br_ops);
    }
  else if  (mode == SFmode)
    {
      output_asm_insn ("c.le.s\t%0,%1\t\t# bleu", br_ops);
      output_asm_insn ("bc1t\t%2\t\t# bleu", br_ops);
    }
  else
    {
      output_asm_insn ("bleu\t%0,%1,%2\t\t# bleu Inv.", br_ops);
    }
  return "";
}

}

static char *
output_94 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  register rtx target = XEXP (operands[0], 0);

  if (GET_CODE (target) == SYMBOL_REF)
    return "jal\t%0";

  else
    {
      operands[0] = target;
      return "jal\t$31,%0";
    }
}
}

static char *
output_95 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  register rtx target = XEXP (operands[1], 0);

  if (GET_CODE (target) == SYMBOL_REF)
    return "jal\t%1";

  else
    {
      operands[1] = target;
      return "jal\t$31,%1";
    }
}
}

static char *
output_97 (operands, insn)
     rtx *operands;
     rtx insn;
{

{
  operands[0] = gen_rtx (REG, SImode, 1);
  operands[1] = stack_pointer_rtx;
  return ".set\tnoat\n\tlw\t%0,0(%1)\t\t# stack probe\n\t.set\tat";
}
}

char * const insn_template[] =
  {
    0,
    "add.d\t%0,%1,%2",
    "add.s\t%0,%1,%2",
    0,
    0,
    "sub.d\t%0,%1,%2",
    "sub.s\t%0,%1,%2",
    0,
    0,
    "mul.d\t%0,%1,%2",
    "mul.s\t%0,%1,%2",
    "mul\t%0,%1,%2",
    "div.d\t%0,%1,%2",
    "div.s\t%0,%1,%2",
    "div\t$0,%1,%2\n\tmflo\t%0\t\t#quotient\n\tmfhi\t%3\t\t#remainder",
    "div\t%0,%1,%2",
    "divu\t$0,%1,%2\n\tmflo\t%0\t\t#quotient\n\tmfhi\t%3\t\t#remainder",
    "divu\t%0,%1,%2",
    "rem\t%0,%1,%2",
    "remu\t%0,%1,%2",
    "abs.s\t%0,%1",
    "abs.d\t%0,%1",
    "and\t%0,%1,%2\n\tand\t%D0,%D1,%D2",
    0,
    "nor\t%0,%1,%2\n\tnor\t%D0,%D1,%D2",
    "nor\t%0,%1,%2",
    "or\t%0,%1,%2\n\tor\t%D0,%D1,%D2",
    0,
    "xor\t%0,%1,%2\n\txor\t%D0,%D1,%D2",
    0,
    "andi\t%0,%1,0xff\t#truncsiqi2\t %1 -> %0",
    0,
    "andi\t%0,%1,0xff\t#trunchiqi2\t %1 -> %0",
    "cvt.s.d\t%0,%1\t#truncdfsf2\t %1 -> %0",
    0,
    0,
    0,
    0,
    0,
    0,
    "cvt.d.s\t%0,%1\t#extendsfdf2\t %1 -> %0",
    "trunc.w.d %0,%1,%2",
    "mfc1\t%0,%1",
    0,
    "trunc.w.s %0,%1,%2",
    "mfc1\t%0,%1",
    0,
    "mtc1\t%1,%0\t\t#floatsidf2\t%1 -> %0\n\tcvt.d.w\t%0,%0",
    "mtc1\t%1,%0\t\t#floatsisf2\t%1 -> %0\n\tcvt.s.w\t%0,%0",
    0,
    0,
    "mfc1\t%0,%L1\n\tmfc1\t%D0,%M1",
    "mfc1\t%0,%L1\n\tmfc1\t%D0,%M1",
    "mfc1\t%0,%L1\n\tmfc1\t%D0,%M1",
    "mfc1\t%0,%L1\n\tmfc1\t%D0,%M1",
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    "sub%:\t%0,$0,%1",
    "neg.d\t%0,%1",
    "neg.s\t%0,%1",
    "nor\t%0,$0,%1",
    0,
    0,
    0,
    0,
    0,
    "j\t%0",
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    ".set\tnoreorder\n\tnop\n\t.set\treorder",
    0,
  };

char *(*const insn_outfun[])() =
  {
    output_0,
    0,
    0,
    output_3,
    output_4,
    0,
    0,
    output_7,
    output_8,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    output_23,
    0,
    0,
    0,
    output_27,
    0,
    output_29,
    0,
    output_31,
    0,
    0,
    output_34,
    output_35,
    output_36,
    output_37,
    output_38,
    output_39,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    output_55,
    output_56,
    output_57,
    output_58,
    output_59,
    output_60,
    output_61,
    output_62,
    output_63,
    0,
    0,
    0,
    0,
    output_68,
    output_69,
    output_70,
    output_71,
    output_72,
    0,
    output_74,
    output_75,
    output_76,
    output_77,
    output_78,
    output_79,
    output_80,
    output_81,
    output_82,
    output_83,
    output_84,
    output_85,
    output_86,
    output_87,
    output_88,
    output_89,
    output_90,
    output_91,
    output_92,
    output_93,
    output_94,
    output_95,
    0,
    output_97,
  };

rtx (*const insn_gen_function[]) () =
  {
    0,
    gen_adddf3,
    gen_addsf3,
    0,
    gen_addsi3,
    gen_subdf3,
    gen_subsf3,
    0,
    gen_subsi3,
    gen_muldf3,
    gen_mulsf3,
    gen_mulsi3,
    gen_divdf3,
    gen_divsf3,
    gen_divmodsi4,
    gen_divsi3,
    gen_udivmodsi4,
    gen_udivsi3,
    gen_modsi3,
    gen_umodsi3,
    gen_abssf2,
    gen_absdf2,
    gen_anddi3,
    gen_andsi3,
    0,
    0,
    gen_iordi3,
    gen_iorsi3,
    gen_xordi3,
    gen_xorsi3,
    gen_truncsiqi2,
    gen_truncsihi2,
    gen_trunchiqi2,
    gen_truncdfsf2,
    gen_zero_extendhisi2,
    gen_zero_extendqihi2,
    gen_zero_extendqisi2,
    gen_extendhisi2,
    gen_extendqihi2,
    gen_extendqisi2,
    gen_extendsfdf2,
    gen_fix_truncdfsi2_internal,
    0,
    gen_fix_truncdfsi2,
    gen_fix_truncsfsi2_internal,
    0,
    gen_fix_truncsfsi2,
    gen_floatsidf2,
    gen_floatsisf2,
    gen_fixuns_truncdfsi2,
    gen_fixuns_truncsfsi2,
    0,
    0,
    0,
    0,
    gen_movdi,
    gen_movsi,
    gen_movhi,
    gen_movqi,
    gen_movsf,
    gen_movdf,
    gen_ashlsi3,
    gen_ashrsi3,
    gen_lshrsi3,
    gen_negsi2,
    gen_negdf2,
    gen_negsf2,
    gen_one_cmplsi2,
    gen_cmpsi,
    0,
    gen_cmpdf,
    gen_cmpsf,
    gen_jump,
    gen_tablejump,
    gen_beq,
    gen_bne,
    gen_bgt,
    gen_blt,
    gen_bgtu,
    gen_bltu,
    gen_bge,
    gen_bgeu,
    gen_ble,
    gen_bleu,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    gen_call,
    gen_call_value,
    gen_nop,
    gen_probe,
  };

const int insn_n_operands[] =
  {
    7,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    4,
    3,
    4,
    3,
    3,
    3,
    2,
    2,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    3,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    3,
    2,
    2,
    3,
    2,
    2,
    2,
    2,
    2,
    2,
    3,
    2,
    3,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    3,
    3,
    3,
    2,
    2,
    2,
    2,
    2,
    1,
    2,
    2,
    0,
    1,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    2,
    3,
    0,
    0,
  };

const int insn_n_dups[] =
  {
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    2,
    0,
    2,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
  };

char *const insn_operand_constraint[][MAX_RECOG_OPERANDS] =
  {
    { "=r", "", "r", "I", "=r", "", "I", },
    { "=f", "f", "f", },
    { "=f", "f", "f", },
    { "=r", "%r", "i", },
    { "=r", "%r", "rI", },
    { "=f", "f", "f", },
    { "=f", "f", "f", },
    { "=r", "%r", "i", },
    { "=r", "r", "rI", },
    { "=f", "f", "f", },
    { "=f", "f", "f", },
    { "=r", "%r", "rI", },
    { "=f", "f", "f", },
    { "=f", "f", "f", },
    { "=r", "r", "rI", "=r", },
    { "=r", "r", "rI", },
    { "=r", "r", "rI", "=r", },
    { "=r", "r", "rI", },
    { "=r", "r", "rI", },
    { "=r", "r", "rI", },
    { "=f", "f", },
    { "=f", "f", },
    { "=&r", "r", "r", },
    { "=r", "%r", "rK", },
    { "=r", "r", "r", },
    { "=r", "r", "r", },
    { "=&r", "r", "r", },
    { "=r", "%r", "rJ", },
    { "=&r", "r", "r", },
    { "=r", "%r", "rK", },
    { "=r", "r", },
    { "=r", "r", },
    { "=r", "r", },
    { "=f", "f", },
    { "=r,r", "r,m", },
    { "=r", "r", },
    { "=r,r", "r,m", },
    { "=r,r", "r,m", },
    { "=r", "r", },
    { "=r,r", "r,m", },
    { "=f", "f", },
    { "=f", "f", "r", },
    { "=r", "f", },
    { "", "", },
    { "=f", "f", "r", },
    { "=r", "f", },
    { "", "", },
    { "=f", "r", },
    { "=f", "r", },
    { "", "", },
    { "", "", },
    { "=ry", "rf", "rf", },
    { "=ry", "rf", },
    { "=rf", "ry", "rf", },
    { "=rf", "ry", },
    { "=r,*r,*m", "r,*miF,*r", },
    { "=r,r,m,r,r,m,*r", "r,m,r,i,J,J,*p", },
    { "=r,r,m,r,r,m", "r,m,r,i,J,J", },
    { "=r,r,m,r,r,m", "r,m,r,i,J,J", },
    { "=f,f,m,fy,*f,*y,*y,*m", "f,m,f,F,*y,*f,*m,*y", },
    { "=f,f,m,fy,*f,*y,&*y,*m", "f,m,f,F,*y,*f,*m,*y", },
    { "=r", "r", "rI", },
    { "=r", "r", "rI", },
    { "=r", "r", "rI", },
    { "=r", "r", },
    { "=f", "f", },
    { "=f", "f", },
    { "=r", "r", },
    { "r", "rI", },
    { "r", },
    { "f", "f", },
    { "f", "f", },
    { 0 },
    { "r", },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { "m", "i", },
    { "=rf", "m", "i", },
    { 0 },
    { 0 },
  };

const enum machine_mode insn_operand_mode[][MAX_RECOG_OPERANDS] =
  {
    { VOIDmode, VOIDmode, VOIDmode, VOIDmode, VOIDmode, VOIDmode, VOIDmode, },
    { DFmode, DFmode, DFmode, },
    { SFmode, SFmode, SFmode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { DFmode, DFmode, DFmode, },
    { SFmode, SFmode, SFmode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { DFmode, DFmode, DFmode, },
    { SFmode, SFmode, SFmode, },
    { SImode, SImode, SImode, },
    { DFmode, DFmode, DFmode, },
    { SFmode, SFmode, SFmode, },
    { SImode, SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { SFmode, SFmode, },
    { DFmode, DFmode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, },
    { DImode, DImode, DImode, },
    { SImode, SImode, SImode, },
    { QImode, SImode, },
    { HImode, SImode, },
    { QImode, HImode, },
    { SFmode, DFmode, },
    { SImode, HImode, },
    { HImode, QImode, },
    { SImode, QImode, },
    { SImode, HImode, },
    { HImode, QImode, },
    { SImode, QImode, },
    { DFmode, SFmode, },
    { DFmode, DFmode, SImode, },
    { SImode, DFmode, },
    { SImode, DFmode, },
    { SFmode, SFmode, SImode, },
    { SImode, SFmode, },
    { SImode, SFmode, },
    { DFmode, SImode, },
    { SFmode, SImode, },
    { SImode, DFmode, },
    { SImode, SFmode, },
    { DImode, DFmode, VOIDmode, },
    { DImode, DFmode, },
    { DFmode, DImode, VOIDmode, },
    { DFmode, DImode, },
    { DImode, DImode, },
    { SImode, SImode, },
    { HImode, HImode, },
    { QImode, QImode, },
    { SFmode, SFmode, },
    { DFmode, DFmode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, SImode, },
    { SImode, SImode, },
    { DFmode, DFmode, },
    { SFmode, SFmode, },
    { SImode, SImode, },
    { SImode, SImode, },
    { SImode, },
    { DFmode, DFmode, },
    { SFmode, SFmode, },
    { VOIDmode },
    { SImode, },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode },
    { VOIDmode, VOIDmode, },
    { VOIDmode, VOIDmode, VOIDmode, },
    { VOIDmode },
    { VOIDmode },
  };

const char insn_operand_strict_low[][MAX_RECOG_OPERANDS] =
  {
    { 0, 0, 0, 0, 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, 0, },
    { 0, },
    { 0, 0, },
    { 0, 0, },
    { 0 },
    { 0, },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0, 0, },
    { 0, 0, 0, },
    { 0 },
    { 0 },
  };

int (*const insn_operand_predicate[][MAX_RECOG_OPERANDS])() =
  {
    { 0, 0, 0, 0, 0, 0, 0, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, immediate_operand, },
    { register_operand, arith_operand, arith_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, immediate_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, arith_operand, arith_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, arith_operand, register_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, register_operand, arith_operand, register_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, uns_arith_operand, uns_arith_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, uns_arith_operand, uns_arith_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, uns_arith_operand, uns_arith_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, general_operand, },
    { register_operand, register_operand, },
    { register_operand, general_operand, },
    { register_operand, general_operand, },
    { register_operand, register_operand, },
    { register_operand, general_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, register_operand, },
    { register_operand, register_operand, },
    { general_operand, general_operand, },
    { general_operand, general_operand, },
    { general_operand, general_operand, },
    { general_operand, general_operand, },
    { general_operand, general_operand, },
    { general_operand, general_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, register_operand, arith_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { register_operand, arith_operand, },
    { register_operand, },
    { register_operand, register_operand, },
    { register_operand, register_operand, },
    { 0 },
    { register_operand, },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { 0 },
    { memory_operand, 0, },
    { 0, memory_operand, 0, },
    { 0 },
    { 0 },
  };

#ifndef DEFAULT_MACHINE_INFO
#define DEFAULT_MACHINE_INFO 0
#endif

const INSN_MACHINE_INFO insn_machine_info[] =
  {
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
     { DEFAULT_MACHINE_INFO },
  };

const int insn_n_alternatives[] =
  {
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    2,
    1,
    2,
    2,
    1,
    2,
    1,
    1,
    1,
     0,
    1,
    1,
     0,
    1,
    1,
     0,
     0,
    1,
    1,
    1,
    1,
    3,
    7,
    6,
    6,
    8,
    8,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
     0,
    1,
     0,
     0,
     0,
     0,
     0,
     0,
     0,
     0,
     0,
     0,
     0,
     0,
     0,
     0,
     0,
     0,
     0,
     0,
     0,
     0,
    1,
    1,
     0,
     0,
  };
