#include <path.h>

/* The following for small time debugging.

#define xrealloc realloc

*/


struct directory_stack *path_to_dir_list(path_name)
char *path_name;
{
  extern char *getenv();
  int dir_count;
  struct directory_stack *dirtemp, *prev_dir;
  char *dir, *path1, *path2;
  char *colon;

  path1 = getenv(path_name);
  path2 = (char*)malloc(strlen(path1)+1); /* 1 for null. */
  strcpy(path2, path1);

  dir_count = count_path_entries(path2);
 
  prev_dir = 0;

  while (dir_count--) {  
    dirtemp = (struct directory_stack *) 
		malloc(sizeof(struct directory_stack));
    dirtemp->next = prev_dir;

    if (colon = rindex(path2, ':')) {
      dirtemp->fname = colon + 1;
      if (!(*(dirtemp->fname))) {
	dirtemp->fname = malloc(sizeof(char) * 2);
	(dirtemp->fname)[0] = '.';
	(dirtemp->fname)[1] = '\0';
      }
      *colon = '\000';
    }
    else {
      dirtemp->fname = path2;
      if (!(*(dirtemp->fname))) {
	dirtemp->fname = malloc(sizeof(char) * 2);
	(dirtemp->fname)[0] = '.';
	(dirtemp->fname)[1] = '\0';
      }
    }

    prev_dir = dirtemp;
  }
  return(prev_dir);
}

int dir_list_len(dir_ptr)
     struct directory_stack *dir_ptr;
{ int path_dirs = 0;
  for (; dir_ptr; dir_ptr = dir_ptr->next) path_dirs++;
  return path_dirs;
}

int count_path_entries(path)
char *path;
{

  char *colon;
  int count = 0;

  while (colon = index(path, ':')) {
    path = ++colon;
    count++;
  }

  count++;

  return(count);
}



/*  The following for small time debgging. 


print_dir_list(list)
struct directory_stack *list;
{

  while (list) {
    printf("%s.\n", list->fname);
    list = list->next;  
  }

}
  

main() 
{

  print_dir_list(path_to_dir_list("CPATH"));

}


*/
